macroScript V4U_AutoUnwrapper
	category:"VRay"
	buttonText:"UNWR"
	toolTip: "Auto unwrapper"
	Icon:#("UVWUnwrapTools", 32)
(
	global unwrapperRoll 
	try (destroydialog unwrapperRoll) catch()
	
	local theSel 
	local msgString = ""
	local skipFaceCount = 70000
	local mapSizes=#()
	local mapCounts=#(0,0,0,0,0,0,0,0)
	local totTris = 0
	local PercentDone = 0
	local SEModeOn=false
	local commandPanelMode=undefined
	local timeSliderWasVisible=undefined
	local trackBarWasVisible=undefined
	local statusPanelWasVisible=undefined
	local expertModeWasActive=undefined
	local matEditorWasOpen=undefined
	local hardConvert = false
	local funBoxMsg = ""
	local funBoxMsgIdx = 1
	local funBoxTimer = dotNetObject "System.Windows.Forms.Timer"
	funBoxTimer.interval = 1000
	local trivia_01 = "The UnwrapUVW consumes lots of memory. It is recommended to run this script on a copy of your scene. "
	local trivia_02 = "Chaos Group is based in Sofia, Bulgaria."
	local turtle_01 = "  ______    ____\n /  \\ / \\  |  o | \n| \\ / \\ /|/ ___\\| \n|_/_\\_/_\\_/     \n|_|_| |_|_|"
	local turtle_02 = "  ______   \n /  \\ / \\   ____\n| \\ / \\ /|-|  o | \n|_/_\\_/_\\_- ___\\|      \n|_||_||_||_|"
	local raytrace_01 = " __________________________\n|                          |\n| *                        |\n|                    _     |\n|                _ .-^-.  _|\n| □<            /_/     \\//|\n|                 \\     // |\n|                  '---'^  |\n ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾"
	local raytrace_02 = " __________________________\n|                          |\n| *                        |\n|  \\                 _     |\n|   \\            _ .-^-.  _|\n| □< \\          /_/     \\//|\n|     \\           \\     // |\n|      \\           '---'^  |\n ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾"
	local raytrace_03 = " __________________________\n|             /            |\n| *          /             |\n|  \\        /        _     |\n|   \\      /     _ .-^-.  _|\n| □< \\    /     /_/     \\//|\n|     \\  /        \\     // |\n|      \\/          '---'^  |\n ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾"
	local raytrace_04 = " __________________________\n|             /\\           |\n| *          /  \\          |\n|  \\        /    \\   _     |\n|   \\      /     _\\.-^-.  _|\n| □< \\    /     /_/O    \\//|\n|     \\  /        \\     // |\n|      \\/          '---'^  |\n ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾"
	local raytrace_05 = " __________________________\n|             /\\           |\n| *          /  \\          |\n|  \\        /    \\   _     |\n|   \\      /     _\\.-^-.  _|\n| □<-\\----/-----/_/O    \\//|\n|     \\  /        \\     // |\n|      \\/          '---'^  |\n ‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾‾"
	local breakCoffee_01 = " This could take a while.\n Go get some\n hot coffee     / /\n                 \\\\\n              _ __/_\n             | |    |\n             |_|V-Ra|\n               |____| "
	local breakCoffee_02 = " This could take a while.\n Go get some\n hot coffee     \\  \\\n                 //\n              _ _\\__\n             | |    |\n             |_|V-Ra|\n               |____|"
	local breakCoffee_03 = " This could take a while.\n Go get some\n fresh air      / /\n                 \\\\\n              _ __/_\n             | |    |\n             |_|V-Ra|\n               |____|"
	local breakCoffee_04 = " This could take a while.\n Go get some\n fresh air      \\  \\\n                 //\n              _ _\\__\n             | |    |\n             |_|V-Ra|\n               |____|"
	local breakCoffee_05 = " This could take a while.\n Go get some\n    snack       / /\n                 \\\\\n              _ __/_\n             | |    |\n             |_|V-Ra|\n               |____|"
	local breakCoffee_06 = " This could take a while.\n Go get some\n    snack        \\  \\\n                 //\n              _ _\\__\n             | |    |\n             |_|V-Ra|\n               |____|"
	local funBoxMsgArr = #(trivia_01,trivia_01,trivia_01,trivia_01,trivia_01,trivia_01,\
		breakCoffee_01,breakCoffee_02,breakCoffee_01,breakCoffee_02,breakCoffee_01,breakCoffee_02,breakCoffee_01,breakCoffee_02,\
		breakCoffee_03,breakCoffee_04,breakCoffee_03,breakCoffee_04,breakCoffee_03,breakCoffee_04,breakCoffee_03,breakCoffee_04,\
		breakCoffee_05,breakCoffee_06,breakCoffee_05,breakCoffee_06,breakCoffee_05,breakCoffee_06,breakCoffee_05,breakCoffee_06,\
		trivia_02,trivia_02,trivia_02,\
		turtle_01, turtle_02,turtle_01, turtle_02,turtle_01, turtle_02,turtle_01, turtle_02,\
		raytrace_01,raytrace_02,raytrace_03,raytrace_04,raytrace_05,raytrace_01,raytrace_02,raytrace_03,raytrace_04,raytrace_05,raytrace_01,raytrace_02,raytrace_03,raytrace_04,raytrace_05,raytrace_01,raytrace_02,raytrace_03,raytrace_04,raytrace_05\
		)
	fn logToFile message =
	(
		logFileName = (getdir #plugcfg) + "\autoUnwrapper.lol"
		 
		-- create the log file
		if not doesFileExist logFileName do 
		(
			logFile = createFile logFileName
			close logFile 
		)
		
		TologFileName = openFile logFileName mode:"at"
		locTime = getLocalTime()
		locTimeStamp = (locTime[5] as String) + ":" + (locTime[6] as String) + ":" + (locTime[7] as String)
		txt = (locTimeStamp as String) + " >>> " + (message as String)
		format "%\n" txt to:TologFileName
		
		close TologFileName
	)
	
	fn deleteLog =
	(
		logFileName = (getdir #plugcfg) + "\autoUnwrapper.log"
		 
		if doesFileExist logFileName do (
			deleteFile logFileName
		)
	)
	fn lognn base val =
	(
		log val / log base
	)		
	
	fn resetUIStatus = 
	(
		timeSliderWasVisible=undefined
		trackBarWasVisible=undefined
		statusPanelWasVisible=undefined
		expertModeWasActive=undefined
		matEditorWasOpen=undefined		
	)
	
	fn getUIStatus =
	(
		timeSliderWasVisible=timeslider.isVisible()
		trackBarWasVisible=trackbar.visible
		statusPanelWasVisible=statusPanel.visible
		expertModeWasActive=cui.getExpertMode() 
		matEditorWasOpen = MatEditor.isOpen()
	)	
	
	fn setSuperExpertMode status =
	(
		if status then 		--if the bool is true/1/on then 
		( 
			getUIStatus()	--we gather the UI status right before  changing it
			timeslider.Setvisible false		--turn off the time slider
			trackbar.visible = false		--turn off the track bar
			cui.expertModeOn()				-- set the UI in expert mode
			statusPanel.visible = false		--hide the status bar as well (consider NOT doing this if showing a progressbar.
			MatEditor.close()
			disableSceneRedraw() --self explanatory														  
			
		)
		
		else 				--if the bool is false/0/off, then 
		(
			--we return the UI to its original state, if those states were correctly gathered, otherwise we default to the standard UI visibility setup
			if commandPanelMode != undefined then 
			(
				setCommandPanelTaskMode(commandPanelMode)
			)
			else 
			(
				setCommandPanelTaskMode(#modify)	
			)
			
			if timeSliderWasVisible != undefined then 
			(
				timeslider.Setvisible timeSliderWasVisible
			)
			else 
			(
				timeslider.Setvisible true	
			)
			
			if trackBarWasVisible != undefined then 
			(
				trackbar.visible = trackBarWasVisible 
			)
			else 
			(
				trackbar.visible = true
			)
			
			if expertModeWasActive != undefined then	
			(
				if not expertModeWasActive do cui.expertModeOff()
			)
			else 
			(
				cui.expertModeOff()
			)
			
			if statusPanelWasVisible != undefined then 
			(
				statusPanel.visible = statusPanelWasVisible 
			)
			else 
			(
				statusPanel.visible = true
			)
			
			if matEditorWasOpen != undefined do 
			(
				if matEditorWasOpen do matEditor.open()
			)
			
			enableSceneRedraw() 																								 
		)
	)	
	fn openAllGroups =
	(
		groups = for o in helpers where isGroupHead o collect o
		while groups.count > 0 do
		(
			setGroupOpen groups[groups.count] true 
			groups.count = groups.count-1
		)
	)
	
	fn getNodeReferences myNode =
	(
		local inst
		InstanceMgr.GetInstances myNode &inst
		for n in inst where not (areNodesInstances myNode n) collect n
	)
	
	fn getNodeInstances myNode =
	(
		local inst
		InstanceMgr.GetInstances myNode &inst
		for n in inst where ((areNodesInstances myNode n) and (n != myNode)) collect n
	)
	
	fn getUniqueGeoSelection =
	(
		with undo off
		(
			with redraw off 
			(
				openAllGroups()
				if unwrapperRoll.chk6.checked then 
					theSel = for s in selection where (superclassof s == geometryClass) and ((classOf s != targetObject) and ( classOf s != VRayProxy )and \
						(classOf s != VRayPlane) and (classOf s != VRaySphere) and (classOf s != VRayClipper) and (classOf s != VRayFur) and \
						(classOf s != VRayInstancer) and (classOf s != VRayMetaball) and (classOf s != VRayScene) and (classOf s != VRayVolumeGrid)) collect s
				else
					theSel = for g in geometry where ( (g.isHidden == false) and (classOf g != targetObject) and ( classOf g != VRayProxy ) and \
						(classOf g != VRayPlane) and (classOf g != VRaySphere) and (classOf g != VRayClipper) and (classOf g != VRayFur) and \
						(classOf g != VRayInstancer) and (classOf g != VRayMetaball) and (classOf g != VRayScene) and (classOf g != VRayVolumeGrid)) collect g
				if theSel.count != 0 then 
				(
					-- remove instances from the selection
					local cleanSel = theSel
					for s in theSel do 
					(
						local instances = getNodeInstances s
						if instances.count > 0 do 
						(
							for i in instances do 
							(
								itemToRemove = findItem cleanSel i
								if itemToRemove > 0 do 
									deleteItem cleanSel itemToRemove
							)
						)
					)
					theSel = cleanSel
				) 
				else 
				(
					messageBox "Nothing selected! Please make a selection first. "
				)
			)
		)
		redrawViews()
	)
	fn getGeoSelectionForAnalyse =
	(
		with undo off
		(
			with redraw off 
			(
				openAllGroups()
				if unwrapperRoll.chk6.checked then 
					theSel = for s in selection where (superclassof s == geometryClass) and ((classOf s != targetObject) and ( classOf s != VRayProxy )and \
						(classOf s != VRayPlane) and (classOf s != VRaySphere) and (classOf s != VRayClipper) and (classOf s != VRayFur) and \
						(classOf s != VRayInstancer) and (classOf s != VRayMetaball) and (classOf s != VRayScene) and (classOf s != VRayVolumeGrid)) collect s
				else
					theSel = for g in geometry where ( (g.isHidden == false) and (classOf g != targetObject) and ( classOf g != VRayProxy ) and \
						(classOf g != VRayPlane) and (classOf g != VRaySphere) and (classOf g != VRayClipper) and (classOf g != VRayFur) and \
						(classOf g != VRayInstancer) and (classOf g != VRayMetaball) and (classOf g != VRayScene) and (classOf g != VRayVolumeGrid)) collect g
				if theSel.count == 0 do
				(
					messageBox "Nothing selected! Please make a selection first. "
				) 
			)
		)
		redrawViews()
	)
	
	fn ConvertSelectionToMeshes hardConvert=
	(
		if theSel.count != 0 do
		(
			if hardConvert then
			(
				for s in theSel do
				(
					if classOf s == vrayProxy do
					(
						s.display = 4
					)
					if ((getPolygonCount s)[1] < skipFaceCount or skipFaceCount == 0) do 
						convertToMesh s
				)
			)
			else
			(
				for s in theSel do
				(
					if classof s == vrayProxy do
					(
						setUserProp s "V4U_ProxyDisplay" s.display
						s.display=4
					)
					for modify in s.modifiers where modify.name == "v4u_meshSelMod" do deletemodifier s modify
					if ((getPolygonCount s)[1] < skipFaceCount or skipFaceCount == 0) do 
					(
						lowestSmooth = 0
						for i=0 to s.modifiers.count where (classof s.modifiers[i] == meshsmooth or classof s.modifiers[i] == turbosmooth) do lowestSmooth = i
						theMod=meshSelect name:"v4u_meshSelMod"
						addmodifier s theMod before:lowestSmooth
					)
				)
			)
		)
	)
	
	fn coloriseMesh inMesh =
	(
		mapSize = try ((getUserProp inMesh "V4U_LMSize") as integer) catch 1
		col=color 191 47 47
		hue=0
		case of
		(
			(mapSize==32):(hue=0)
			(mapSize==64):(hue=12)
			(mapSize==128):(hue=24)
			(mapSize==256):(hue=36)
			(mapSize==512):(hue=48) 
			(mapSize==1024):(hue=60)
			(mapSize==2048):(hue=72)
			(mapSize==4096):(hue=84)
			default:(hue=170)
		)
		col.h=hue
		inMesh.wirecolor=col
	)
	
	fn getLastUVChannel obj = 
	(
		local lastUVID = 1
		local count = 0
		if classof obj == Editable_Poly or classof obj == PolyMeshObject then 
		(
			for i in 1 to polyOp.getNumMaps obj do
				if polyOp.getMapSupport obj i then 
				(
					count += 1
					if lastUVID < i then lastUVID = i
				)
		) else (
			for i in 1 to meshOp.getNumMaps obj do
				if meshOp.getMapSupport obj i then 
				(
					count += 1
					if lastUVID < i then lastUVID = i
				)
		)
		return lastUVID
	)
	
	fn analyseMesh theMesh diGamma deGamma bbGamma doReadOnly=
	(
		nd=0
		numFaces=1
		meshDiagonal=1
		sceneDiagonal=1
		if not doReadOnly then
		(
			lowestSmooth = 0
			for i=0 to theMesh.modifiers.count where (classof theMesh.modifiers[i] == meshsmooth or classof theMesh.modifiers[i] == turbosmooth) do lowestSmooth = i
			theMod=meshSelect name:"v4u_tempMeshSelMod"
			addmodifier theMesh theMod before:lowestSmooth
			
			normalsArray=#()
			normalsDotsArray=#()
			numFaces = (getNumFaces theMesh)
			totTris+=numFaces
			for f=1 to numFaces do
			(
				windows.processPostedMessages()
				append normalsArray (getFaceNormal theMesh f)
			)
			
			for n=1 to numFaces do
			(
				windows.processPostedMessages()
				if n<normalsArray.count then
				(
					append normalsDotsArray (dot normalsArray[n] normalsArray[n+1])
				)
				else
				(
					append normalsDotsArray (dot normalsArray[n] normalsArray[1])
				)
			)
			
			for d in normalsDotsArray where  d<=0.0 do 
			(
				nd+=1
			)
			
			
			sceneBBox = geometry.max - geometry.min
			sceneDiagonal = sqrt (sceneBBox[1]^2+sceneBBox[2]^2+sceneBBox[3]^2)
			meshBBox = theMesh.max - theMesh.min
			meshDiagonal = sqrt (meshBBox[1]^2+meshBBox[2]^2+meshBBox[3]^2)
			
			-- atomic props			
			setuserprop theMesh "V4U_Atomic_nd" (nd as string)
			setuserprop theMesh "V4U_Atomic_numFaces" (numFaces as string)
			setuserprop theMesh "V4U_Atomic_sceneBBox" (sceneBBox as string)
			setuserprop theMesh "V4U_Atomic_sceneDiagonal" (sceneDiagonal as string)
			setuserprop theMesh "V4U_Atomic_meshBBox" (meshBBox as string)
			setuserprop theMesh "V4U_Atomic_meshDiagonal" (meshDiagonal as string)	
			
			for modify in theMesh.modifiers where modify.name == "v4u_tempMeshSelMod" do deletemodifier theMesh modify
		)
		else --read the props to assign vars
		(
			nd = try ((getUserProp theMesh "V4U_Atomic_nd") as integer) catch 0
			numFaces=try ((getUserProp theMesh "V4U_Atomic_numFaces") as integer) catch 1
			sceneDiagonal=try ((getUserProp theMesh "V4U_Atomic_sceneDiagonal") as integer) catch 1
			meshDiagonal=try ((getUserProp theMesh "V4U_Atomic_meshDiagonal") as integer) catch 1
			
		)
		
		discontinuityFactor=(nd as float /numFaces)^diGamma
		
		densityFactor=((lognn 100 numFaces) / 6.0)^deGamma
		
		bboxFactor = (meshDiagonal / sceneDiagonal)^bbGamma
		
		mapFactor = 0 + ((((discontinuityFactor) + (densityFactor) + (bboxFactor) ) / 1 )*7) + 4
		if mapFactor > 12 do mapFactor=12
		mapSize = 2 ^ (ceil mapFactor)
		append mapSizes mapSize
		
		--computed props
		setuserprop theMesh "V4U_DiF" (discontinuityFactor as string)
		setuserprop theMesh "V4U_DeF" (densityFactor as string)
		setuserprop theMesh "V4U_BbF" (bboxFactor as string)			
		setuserprop theMesh "V4U_LMSize" (mapSize as string)

		if unwrapperRoll.subRoll.experimentalRoll.chk3.checked do coloriseMesh theMesh
	)
	
	fn countMapsSizes =
	(
		mapCounts=#(0,0,0,0,0,0,0,0) 
		for m in mapsizes do
		(
			case m of
			(
				4096: (mapCounts[8]+=1)
				2048: (mapCounts[7]+=1)
				1024: (mapCounts[6]+=1)
				 512: (mapCounts[5]+=1)
				 256: (mapCounts[4]+=1)
				 128: (mapCounts[3]+=1)
				  64: (mapCounts[2]+=1)
				  32: (mapCounts[1]+=1)
			)
		)
		
	)
	
	fn analyseSelection colOnly =
	(
		hardConvert = not unwrapperRoll.chk5.checked
		if theSel.count != 0 do
		(
			st=timestamp()
			msgString=""
			totTris = 0
			mapSizes=#()
			pbCol=red
			pbCol.h=0
			unwrapperRoll.pb1.color=pbCol
			if not colOnly then
			(
				for obj=1 to theSel.count do
				(
					windows.processPostedMessages()
					analyseMesh theSel[obj] unwrapperRoll.subRoll.experimentalRoll.spnDi.value unwrapperRoll.subRoll.experimentalRoll.spnDe.value unwrapperRoll.subRoll.experimentalRoll.spnBb.value false
					perc=(obj as float/theSel.count)
					unwrapperRoll.pb1.value=perc*100
					pbCol.h=84.0*perc
					unwrapperRoll.pb1.color=pbCol
					unwrapperRoll.lblTimer.text=("Timer (s.): " + ((timestamp()-st)/1000.0) as string )
					if not hardConvert do 
					(
						try (deleteModifier theSel[obj] theSel[obj].modifiers.count ) catch ()
						if classof theSel[obj] == vrayProxy do 
							try (theSel[obj].display=(getUserProp theSel[obj] "V4U_ProxyDisplay") as integer) catch (print theSel[obj])
					)
				)
			)
			else
			(
				for obj=1 to theSel.count do
				(
					analyseMesh theSel[obj] unwrapperRoll.subRoll.experimentalRoll.spnDi.value unwrapperRoll.subRoll.experimentalRoll.spnDe.value unwrapperRoll.subRoll.experimentalRoll.spnBb.value true
					coloriseMesh theSel[obj]
				)
			)
			totTime=timestamp()-st
			if totTime > 36000 then totTime-=36000
			
			msgString="It took " + (totTime/1000.0) as string + "seconds to process " + theSel.count as string + " node(s) and " + totTris as string + " triangles."
			print msgString
			countMapsSizes()
			displaycolor.wireframe=#object
			displaycolor.shaded=#object
		)
	)

	fn flattenSelection =
	(
		if theSel.count != 0 do
		(
			logToFile("Unwrapping started!") 
			-- Sets the command panel to modify in order flatten to work 
			setCommandPanelTaskMode(#modify)
			st=timestamp()
			clearselection()
			pbCol=red
			pbCol.h=0
			perc = 0.01
			unwrapperRoll.pb1.color=pbCol
			obj = 0
			skippedObjects = #()
			with undo off
			(
				with redraw off 
				(
					for s in theSel do
					(
						
						if ((getPolygonCount s)[1] > skipFaceCount and skipFaceCount != 0) then 
						(
							logToFile("WARNING: Skipping high face count object " + (s as string) + " with handleID: " + (s.inode.handle as String)) 
							append skippedObjects s
						) else
						(
							logToFile("Current object: " + (s as string) + " with handleID: " + (s.inode.handle as String)) 
							select s
							
							for modify in s.modifiers where modify.name == "v4u_unwrapMod" do deletemodifier s modify
							unwrapMod=unwrap_UVW name:"v4u_unwrapMod"
							unwrapMod.setMapChannel (getLastUVChannel(s) + (if unwrapperRoll.chk2.checked then 1 else 0))
							unwrapMod.setApplyToWholeObject true
							
							lowestSmooth = 0
							for i=0 to s.modifiers.count where (classof s.modifiers[i] == meshsmooth or classof s.modifiers[i] == turbosmooth) do lowestSmooth = i
							addmodifier s unwrapMod before:lowestSmooth
							
							unwrapMod.flattenMap 30.0 #([1,0,0], [-1,0,0], [0,1,0], [0,-1,0], [0,0,1], [0,0,-1]) 0.001 true 2 true true
							subobjectLevel = 0
							if hardConvert do 
							(
								convertToMesh s
							)
							logToFile("Finished object: " + (s as string) + " with handleID: " + (s.inode.handle as String)) 
						)
						windows.processPostedMessages()
						obj += 1
						perc=(obj as float/theSel.count)
						unwrapperRoll.pb1.value=perc*100
						pbCol.h=84.0*perc
						unwrapperRoll.pb1.color=pbCol
					)
					if selectionsets["v4u_skippedObjects"] == undefined do selectionsets["v4u_skippedObjects"] = #()
					
					NamedSelectionSetManager.ReplaceNamedSelSetByName skippedObjects "v4u_skippedObjects"
				)
			)
			redrawViews()
			
			totTime=timestamp()-st
			unwrapperRoll.lblTimer.text=("Timer (s.): " + (totTime/1000.0) as string )
			
			if totTime > 36000 then totTime-=36000
			
			msgString="It took " + (totTime/1000.0) as string + "seconds to unwrap " + theSel.count as string + " node(s)."
			logToFile(msgString) 
		)
	)

	fn removeUnwrapSelected =
	(				
		pbCol=red
		pbCol.h=0
		unwrapperRoll.pb1.color=pbCol
		obj = 0
		if theSel.count != 0 do
		(
			with undo off
			(
				with redraw off 
				(
					clearselection()
					for s in theSel do
					(
						select s
						for modify in s.modifiers where modify.name == "v4u_unwrapMod" do deletemodifier s modify
						for modify in s.modifiers where modify.name == "v4u_meshSelMod" do deletemodifier s modify
						
						windows.processPostedMessages()
						obj += 1
						perc=(obj as float/theSel.count)
						unwrapperRoll.pb1.value=perc*100
						pbCol.h=84.0*perc
						unwrapperRoll.pb1.color=pbCol
					)
				)
			)
			redrawViews()
			select theSel
		)
	)
	
	fn collapseSelected =
	(
		pbCol=red
		pbCol.h=0
		unwrapperRoll.pb1.color=pbCol
		obj = 0
		if theSel.count != 0 do
			(
				clearselection()
				for s in theSel do
				(		
					select s
					maxOps.CollapseNodeTo s 1 true
					windows.processPostedMessages()
					obj += 1
					perc=(obj as float/theSel.count)
					unwrapperRoll.pb1.value=perc*100
					pbCol.h=84.0*perc
					unwrapperRoll.pb1.color=pbCol
				)
			)
	)
	
	fn getUnprocessedObjects = 
	(
		local objToProc
		if theSel.count != 0 do
		(
			with undo off
			(
				with redraw off 
				(
					objToProc = for s in theSel collect if (for m in s.modifiers while m.name == "v4u_unwrapMod" collect m).count > 0 then dontcollect else s
				)
			)
			redrawViews()
		)
		theSel = objToProc
	)

	rollout experimentalRoll "Experimental" 
	(
		button 'btn3' "Analyse Meshes and Suggest Map Sizes" pos:[8,0] width:262 height:40 align:#left
		spinner 'spnDi' "" pos:[224,46] width:64 height:16 align:#left range:[0.0,10.0,0.4545] type:#float
		label 'lbl3' "Discontinuity Gamma:" pos:[8,46] width:104 height:16 align:#left
		spinner 'spnDe' "" pos:[224,68] width:64 height:16 align:#left range:[0.0,10.0,0.6666] type:#float
		label 'lbl4' "Density Gamma:" pos:[8,68] width:104 height:16 align:#left		
		spinner 'spnBb' "" pos:[224,90] width:64 height:16 align:#left range:[0.0,10.0,0.9] type:#float
		label 'lbl5' "bBoxGamma" pos:[8,90] width:104 height:16 align:#left
		checkbox 'chk3' "Colorise Wireframes by map size" pos:[8,110] width:200 height:16 align:#left checked:true
		checkbox 'chk4' "Read Props and Colorize only" pos:[8,130] width:272 height:16 align:#left checked:false
		
		on btn3 pressed do
		(
			if keyboard.controlPressed then setSuperExpertMode off
			else
			(
				setSuperExpertMode on
					
				if unwrapperRoll.chk1.checked do 
				( 
					--messageBox "About to Hold the Max File..."
					holdMaxFile()
					unwrapperRoll.chk1.checked = false
				)
				getGeoSelectionForAnalyse()
				
				if not chk4.checked then 
				(
					hardConvert = not unwrapperRoll.chk5.checked
					ConvertSelectionToMeshes hardConvert	
					analyseSelection false
				)
				else
				(
					analyseSelection true
				)
				setSuperExpertMode off
			)
		)
	)

	fn funBoxUpdate=
	(
		unwrapperRoll.dn_funBox.text = funBoxMsgArr[funBoxMsgIdx]
		if funBoxMsgIdx == funBoxMsgArr.count then funBoxMsgIdx = 1 else funBoxMsgIdx+=1
	)


	fn funBoxCtrl turnOn = 
	(
		if turnOn then 
		(
			removeSubRollout unwrapperRoll.subRoll unwrapperRoll.subRoll.experimentalRoll
			unwrapperRoll.dn_funBox.font = dotnetobject "System.Drawing.Font" "Courier New" 11
			unwrapperRoll.dn_funBox.forecolor = unwrapperRoll.dn_funBox.forecolor.fromARGB 255 255 255
			unwrapperRoll.dn_funBox.backcolor = unwrapperRoll.dn_funBox.backcolor.fromARGB 0 0 0 
			unwrapperRoll.dn_funBox.visible = true
			funBoxUpdate()
			funBoxTimer.start()
		) 
		else 
		(
			funBoxTimer.stop()
			unwrapperRoll.dn_funBox.visible = false
			
			AddSubRollout unwrapperRoll.subRoll experimentalRoll rolledUp:true
		)
		
	)
	-- Event handler for the timer
	dotnet.addEventHandler funBoxTimer "tick" funBoxUpdate
	
	
	rollout unwrapperRoll "Auto unwrapper" width:296 height:400
	(
		label 'lbl1' "Unwraps the selected objects with UnwrapUVW/Flatten " pos:[8,8] width:280 height:20 align:#left
		checkbox 'chk1' "HOLD scene" pos:[8,36] width:76 height:16 enabled:true checked:false align:#left toolTip:"Enable this to make a temp HOLD copy of the scene, that you can fetch back to its original state later. "
		checkbox 'chk2' "Append UV chan" pos:[84,36] width:94 height:16 align:#left checked:true toolTip:"Adds a new UV channel with the unwrap result. If disabled, overwrites the last existing channel. "
		spinner 'skipSpn' "Skip count" pos:[184,38] width:72 height:16 align:#left range:[0,10000000,500000] type:#integer toolTip:"Objects with higher tri count than this will not be unwrapped. Set to 0 to unwrap every object. "
		checkbox 'chk5' "Add modifier" pos:[8, 56] width:80 height:16 alighn:#left checked:true toolTip:"Keeps the UnwrapUVW modifier in the stack. Disable to collapse the result during unwrapping to save memory. "
		checkbox 'chk6' "Selected only" pos:[84,56] width:94 height:16 align:#left checked:false toolTip:"Unwraps only the selected objects. If disabled, the whole scene will be processed. "
		button 'btn1' "Unwrap with flatten" pos:[8,80] width:280 height:40 enabled:true align:#left toolTip:"Starts the unwrapping process. This may take a while :)"
		button 'btn2' "Remove (or CTRL to collapse) unwrapping result" pos:[8,128] width:280 height:40 enabled:true align:#left toolTip:"Removes the UnwrapUVW"
		
		subrollout 'subRoll' "Experimental"pos:[3,175] width:290 height:174 align:#left
		dotNetControl dn_funBox "System.Windows.Forms.Label" pos:[8,175] width:280 height:160 --create a LABEL DotNetControl
		
		progressBar 'pb1' "" pos:[8,354] width:280 height:16 Alight:#left align:#left
		label 'lblTimer' "Timer (s.): 0.000" pos:[104,374] width:120 height:16 Alight:#left align:#left

		on btn1 pressed do
		(
			if keyboard.controlPressed then 
			(
				
				-- selects objects without the unwrap modifier
				setWaitCursor()
				setSuperExpertMode on
				funBoxCtrl true
				getUniqueGeoSelection()
				getUnprocessedObjects()
				if theSel != undefined do select theSel
				funBoxCtrl false
				setSuperExpertMode off
				setArrowCursor()
			)
			else 
			(
				if chk1.checked do 
				( 
					--messageBox "About to Hold the Max File..."
					holdMaxFile()
					chk1.checked = false
				)
				
				setWaitCursor()
				--setSuperExpertMode on
				funBoxCtrl true
				skipFaceCount = skipSpn.value
				getUniqueGeoSelection()
				
				hardConvert = not unwrapperRoll.chk5.checked
				ConvertSelectionToMeshes hardConvert
				flattenSelection()
				funBoxCtrl false
				--setSuperExpertMode off
				setArrowCursor()
			)
		)
		on btn2 pressed do
		(
			funBoxCtrl true
			getUniqueGeoSelection()
			if keyboard.controlPressed then collapseSelected()
				else 
				(
					setWaitCursor()
					--setSuperExpertMode on
					removeUnwrapSelected()
					--setSuperExpertMode off
					setArrowCursor()
				)
			funBoxCtrl false
		)
		
	)
	
	createDialog unwrapperRoll
	AddSubRollout unwrapperRoll.subRoll experimentalRoll rolledUp:true
	deleteLog()
)